import { Component, ViewChild } from '@angular/core';
import { IgxTreeComponent } from 'igniteui-angular';
import { DATA } from '../../../data/animations-data';

@Component({
  selector: 'app-tree-basic-sample',
  templateUrl: './tree-basic-sample.component.html',
  styleUrls: ['./tree-basic-sample.component.scss'],
})
export class TreeBasicSampleComponent {
  @ViewChild('tree', { read: IgxTreeComponent })
  public tree: IgxTreeComponent;
  public data = DATA;
  public selectedNode;
  constructor() {}
  public ngAfterViewInit() {
    // const selectors = Array.from(
    //   this.tree.nativeElement.querySelectorAll('.igx-tree-node__select')
    // );
    // selectors.forEach((element) => {
    //   (element as HTMLElement).style.visibility = 'hidden';
    // });
    this.tree.nodes.forEach((node) => {
      node.nativeElement.addEventListener('click', (evt) =>
        this.onClick(node, evt)
      );
    });
  }
  public onClick(node, event) {
    if (
      event.target.ariaLabel !== 'Expand' &&
      event.target.ariaLabel !== 'Collapse'
    ) {
      event.preventDefault();
      event.stopPropagation();
      this.selectNode(node);
      this.selectedNode = node;
      this.customFunction();
    }
  }

  public selectNode(clickedNode) {
    this.tree.nodes.forEach((node) => {
      node.selected = false;
    });
    clickedNode.selected = true;
  }

  public customFunction() {
    console.log('execute custom function');
    console.log('Selected Node is: ', this.selectedNode);
  }
}
